package com.dsic.gj_erp.pc;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.SpringContextHolder;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.data.按批次合并的钢料需求;
import com.dsic.gj_erp.pc.dto.data.钢料需求;
import com.dsic.gj_erp.pc.dto.gx.*;
import com.dsic.gj_erp.pc.dto.sb.*;
import com.dsic.gj_erp.pc.dto.tlt.*;
import com.dsic.gj_erp.pc.dto.排产结果;
import com.dsic.gj_erp.pc.dto.*;
import com.dsic.gj_erp.pc.service.工序CD接口;
import com.dsic.gj_erp.pc.service.订货计划滚动信息接口;
import com.dsic.gj_erp.pc.service.设备产能接口;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import com.dsic.gj_erp.service.jhgk.DmZrcjhService;
import com.google.common.collect.ImmutableMap;
import com.google.common.util.concurrent.AtomicDouble;
import lombok.extern.slf4j.Slf4j;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

import static com.dsic.gj_erp.pc.Manager.排产;
import static com.dsic.gj_erp.pc.Manager.*;

@Slf4j
public class DataFactory {

    public static void 排产2() {
        装载中日程数据();
        套料图所占工序的资源.clear();
        Manager.排产结果=new ArrayList<>();
        List<钢料需求> list=读取钢料需求();
        工序CD接口 _工序CD接口 = getBean(工序CD接口.class);
        List<工序CD> 工序CDS = _工序CD接口.get();
        Map<Constant.工序,工序CD> 工序CDMap=new HashMap<>();
        工序CDS.forEach(item->工序CDMap.put(item.getGx(),item));

        执行排产(list,工序CDMap);

        清理冗余数据(list);

        if (Manager.排产结果.size()>0){
            log.info("排产异常--{}个未完整排产,{}",Manager.排产结果.size(),Manager.排产结果);
        }
    }

    private static void 执行排产(List<钢料需求> list, Map<Constant.工序, 工序CD> 工序CDMap){
        list.forEach(钢料需求 -> {
            CountDownLatch latch = new CountDownLatch(钢料需求.getBomList().size());
            String xzglxq = 钢料需求.getXzglxq();
            String dzglxq = 钢料需求.getDzglxq();

            钢料需求.getBomList().forEach(bom -> {
                套料图工序 _套料图工序 = 套料图工序工厂(bom);

                //套料图未定义/定义错误
                if (_套料图工序==null){
                    latch.countDown();
                    return;
                }

                _套料图工序.setXzglxq(xzglxq);
                _套料图工序.setDzglxq(dzglxq);
                _套料图工序.set工序CD(工序CDMap);
                _套料图工序.set中日程(获取中日程(bom.getDcch() + bom.getPl() + bom.getFd()));

                es.execute(() -> {
                    try{
                        _套料图工序.run();
                    }finally {
                        latch.countDown();
                    }
                });
            });
            try {
                latch.await(10, TimeUnit.SECONDS);// 指定超时时间
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        });
    }

    private static DmZrcjh 获取中日程(String key){
        return getBean(DmZrcjhService.class).排产获取中日程数据(key);
    }
    private static void 装载中日程数据(){
        getBean(DmZrcjhService.class).排产中日程数据加载();
    }

    private static void 清理冗余数据(List<钢料需求> list){

        list.forEach(钢料需求->{
            钢料需求.getBomList().forEach(bom -> {
                if (bom.get所在设备()!=null){
                    bom.set所在设备(null);
                }
                if (bom.get所在资源()!=null){
                    bom.set所在资源(null);
                }
            });
        });
    }

    public static void 排产3(){
        装载中日程数据();
        套料图所占工序的资源.clear();
        Manager.排产结果=new ArrayList<>();

        List<钢料需求> list=读取钢料需求();
        Collection<按批次合并的钢料需求> 按批次合并 = 按批次合并(list);
        计算需求产能(按批次合并);
        try {
            均衡预占(按批次合并);
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            清理冗余数据(list);
        }

    }

    public static void 均衡预占(Collection<按批次合并的钢料需求> _按批次合并的钢料需求){
        工序CD接口 _工序CD接口 = getBean(工序CD接口.class);
        List<工序CD> 工序CDS = _工序CD接口.get();
        Map<Constant.工序,工序CD> 工序CDMap=new HashMap<>();
        工序CDS.forEach(item->工序CDMap.put(item.getGx(),item));

        for (按批次合并的钢料需求 item:_按批次合并的钢料需求){
            if (ObjUtil.isNotEmpty(item.getBomList())){
                均衡计算(item,工序CDMap);
            }
        }
    }

    private static void 均衡计算(按批次合并的钢料需求 item,Map<Constant.工序,工序CD> 工序CDMap){
        Constant.工序 依据工序=Constant.工序.切割;
        //需求日期可利用范围是±3天
        int times=-3;
        List<资源> tmpList=new ArrayList<>();
        AtomicDouble atomicDouble = item.get产能需求().get(依据工序);
        资源 _资源=null;
        do {
            //因为第一次计算时候就是当前批量小组需求日期,所以再次循环到的时候不需要再次计算
            if (times==0){
                times+=1;
                continue;
            }
            if (times>3){
                break;
            }
            DateTime xzglxq = item.get均衡需求日期().offset(DateField.DAY_OF_YEAR,工序CDMap.get(依据工序).getCd());
            if (xzglxq.isBefore(DateUtil.date())){
                break;
            }
            _资源 = 提取资源(xzglxq);
            if (_资源.get_date().isBefore(DateUtil.date())){
                break;
            }
            tmpList.add(_资源);
            if (_资源.判断工序是否可以被占用(依据工序,atomicDouble.get())){
//                DateTime 上料日期 = item.get均衡需求日期().offset(DateField.DAY_OF_YEAR, -14);
//                资源 上料 = 提取资源(上料日期);
//                for (Bom bom:item.getBomList()){
//                    上料.占用资源(Constant.工序.上料,bom,item.get产能需求().get(Constant.工序.上料).get());
//                    _资源.占用资源(Constant.工序.切割,bom,1);
//                }
                执行排产(item.getBomList(),item.get均衡需求日期(),工序CDMap);
                break;
            }
            //需求日期可利用范围是±3天,排产是需要根据产能进行调整
            item.set均衡需求日期(DateUtil.offsetDay(item.get均衡需求日期(),times));
            times+=1;
        }while (true);

        //若在需求期±3天内无法正常排产时,查找最大可用空闲资源进行占用
        if (times>3){
            //查找最小可用资源,进行占用
            tmpList.sort(Comparator.comparingDouble((tmp)->tmp.get工序产能MAP().get(Constant.工序.切割).get占用()));
            tmpList.stream().findFirst().ifPresent(tmp->{
//                DateTime 上料日期 = item.get均衡需求日期().offset(DateField.DAY_OF_YEAR, -14);
//                资源 上料 = 提取资源(上料日期);
//                for (Bom bom:item.getBomList()){
//                    上料.占用资源(Constant.工序.上料,bom,item.get产能需求().get(Constant.工序.上料).get());
//                    tmp.占用资源(Constant.工序.切割,bom,1);
//                }
                //由于资源日为切割日期,这里需要还原一下,修正传递的参照需求日期
                执行排产(item.getBomList(),tmp.get_date().offset(DateField.DAY_OF_YEAR,-工序CDMap.get(依据工序).getCd()),工序CDMap);
            });
        }
        if (_资源!=null){
            log.info("船号:{},批次:{},占用资源成功,切割日期:{}",item.getDcCh(),item.getDcPl(),_资源.getDate());
        }else {
            log.info("船号:{},批次:{},早于当前日期无需排产",item.getDcCh(),item.getDcPl());
        }

    }

    private static void 执行排产(List<Bom> list,DateTime 参照需求日期,Map<Constant.工序,工序CD> 工序CDMap){
        CountDownLatch latch = new CountDownLatch(list.size());
        for (Bom bom:list){
            套料图工序 _套料图工序 = 套料图工序工厂(bom);

            if (_套料图工序==null){
                latch.countDown();
                continue;
            }

            _套料图工序.setXzglxq(bom.getXzglxq());
            _套料图工序.setDzglxq(bom.getDzglxq());
            _套料图工序.set工序CD(工序CDMap);
            _套料图工序.set中日程(获取中日程(bom.getDcch() + bom.getPl() + bom.getFd()));
            _套料图工序.set参照需求日期(参照需求日期);
            es.execute(() -> {
                try{
                    _套料图工序.run();
                }finally {
                    latch.countDown();
                }
            });
        }
        try {
            latch.await(30, TimeUnit.SECONDS);// 指定超时时间
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    private static void 计算需求产能(Collection<按批次合并的钢料需求> _按批次合并的钢料需求){
        _按批次合并的钢料需求.forEach(按批次合并的钢料需求::计算各工序产能需求);
    }

    private static Collection<按批次合并的钢料需求> 按批次合并(List<钢料需求> list){
        Map<String,按批次合并的钢料需求> map=new HashMap<>();
        list.forEach(item->{
            String key=item.getDcCh() + item.getDcPl();
            按批次合并的钢料需求 _按批次合并的钢料需求 = map.get(key);
            if (_按批次合并的钢料需求==null){
                _按批次合并的钢料需求=new 按批次合并的钢料需求();
                map.put(key,_按批次合并的钢料需求);
            }
            _按批次合并的钢料需求.of(item);
        });
        return map.values();
    }

    public static List<钢料需求> 读取钢料需求(){
        List<DmSygdxq> 按需求日期排序的钢料需求 = getBean(DmSygdxqService.class).getXqWithBom(from, to);
        return 按需求日期排序的钢料需求.stream().map(钢料需求::of).collect(Collectors.toList());
    }

    private static Map<String,List<订货计划>> _订货计划=new HashMap<>();
    public static List<订货计划> 获取订货计划(String dcch){
        List<订货计划> list=_订货计划.get(dcch);
        if (list!=null){
            return list;
        }
        List<订货计划> _订货计划 = getBean(订货计划滚动信息接口.class).get();
        Map<String,List<订货计划>> map= _订货计划.stream().collect(Collectors.groupingBy(订货计划::getDcch));
        return map.get(dcch);
    }

    public static void 排产() {
        套料图所占工序的资源.clear();
        List<排产结果> list = 排产.list;
        List<DmBom> 强占记录 = new ArrayList<>();
        list.clear();
        List<DmSygdxq> 按需求日期排序的钢料需求 = getBean(DmSygdxqService.class).getXqWithBom(from, to);

        按需求日期排序的钢料需求.forEach(钢料需求 -> {
            钢料需求.getBomList().forEach(bom -> {
                Arrays.stream(Constant.工序.values()).forEach(gx -> {
                    if (StrUtil.isEmpty(gx.getCode())) return;
                    //todo 由于工序code存在多个值的情况,这里需要抽象套料图工序,修改后同时可支持多线程运算
                    Optional<String> first = 套料图工序对应关系.keySet().stream()
                            .filter(it -> it.startsWith(bom.getKw() + bom.getZl()))
                            .filter(it -> gx.getCode().contains(it.split("_")[1])).findFirst();
                    first.ifPresent(_code -> {
                        if (ObjUtil.isNotEmpty(套料图工序对应关系.get(_code))) {
                            Integer cd = Constant.工序CD.get(gx);
                            DateTime parse = DateUtil.parse(钢料需求.getXzglxq(), "yyyy/MM/dd");
                            DateTime dateTime = DateUtil.offsetDay(parse, cd);
                            资源 _资源 = 提取资源(dateTime);
                            //除切割工序外默认需求数量都是1
                            //todo 如果是切割工序需要获取切割长度
                            double 需求数量 = bom.getTlsl().doubleValue();
                            Optional.of(_资源).ifPresent(it -> {
                                工序产能 工序产能 = null;
                                资源 资源 = 套料图所占工序的资源.get(bom.getTzbh());
                                if (资源 != null) {
                                    工序产能 = 资源.get工序产能MAP().get(gx);
                                }
                                if (工序产能 != null && 工序产能.get资源占用图纸表().contains(bom.getTzbh())) {
                                    bom.set所在资源(it);
                                    Optional<设备> _设备 = 工序产能.获取已占用设备(bom.getTzbh());
                                    _设备.ifPresent(bom::set所在设备);
                                } else {
                                    工序产能 = it.get工序产能MAP().get(gx);
                                    Optional<设备> _设备 = 工序产能.获取可占用设备(需求数量);
                                    工序产能 final工序产能 = 工序产能;
                                    _设备.ifPresent(tmp -> {
                                        bom.set所在设备(tmp);
                                        tmp.占用设备(bom.getTzbh(), 需求数量);
                                        bom.set所在资源(it);
                                        final工序产能.占用资源(bom.getTzbh(), 需求数量);
                                        套料图所占工序的资源.put(bom.getTzbh(), it);
                                    });
                                }
                            });

                            //没有可用资源是全局搜索可用资源,进行排产
                            if (bom.get所在设备() == null) {
                                Optional<资源> 可用资源 = 搜索可用资源(gx, DateUtil.parse(from, "yyyy/MM/dd"), parse, 需求数量);
                                可用资源.ifPresent(tmp资源 -> {
                                    工序产能 _工序产能 = tmp资源.get工序产能MAP().get(gx);
                                    Optional<设备> _设备 = _工序产能.获取可占用设备(0);
                                    _设备.ifPresent(tmp -> {
                                        tmp.占用设备(bom.getTzbh(), 需求数量);
                                        bom.set所在设备(tmp);
                                        _工序产能.占用资源(bom.getTzbh(), 需求数量);
                                        bom.set所在资源(tmp资源);
                                        套料图所占工序的资源.put(bom.getTzbh(), tmp资源);
                                    });
                                });
                            }

                            //没有可用资源放入月末(强占),待手工调整
                            if (bom.get所在设备() == null) {
                                强占记录.add(bom);
                                资源 tmp资源 = 提取资源(DateUtil.endOfMonth(DateUtil.parse(钢料需求.getXzglxq(), "yyyy/MM/dd")));
                                工序产能 _工序产能 = tmp资源.get工序产能MAP().get(gx);
                                Optional<设备> _设备 = _工序产能.get设备().values().stream().findAny();
                                bom.set所在设备(_设备.orElse(null));
                                bom.set所在资源(tmp资源);
                                _工序产能.占用资源(bom.getTzbh(), 0);
                                套料图所占工序的资源.put(bom.getTzbh(), tmp资源);
                            }
                        }
                    });
                });
            });
        });
//        Manager.排产结果=按需求日期排序的钢料需求;
        //========调试打印===========
        资源池.forEach((day,item)->{
            System.out.println("====打印资源===");
            System.out.println(day);
            Map<Constant.工序, 工序产能> 工序产能MAP = item.get工序产能MAP();
            工序产能MAP.forEach((工序,工序产能)->{
                if (工序产能.get资源占用图纸表().size()>0){
                    System.out.println("工序:"+工序);
                    if ("2024/06/03".equals(day)){
                        System.out.println(工序产能.get资源占用图纸表());
                    }
                    System.out.println("工序产能:"+工序产能.get资源占用图纸表().size());
                }
            });
            System.out.println("====打印资源完成===");
        });
        System.out.println(强占记录.size());
        //========调试打印结束===========
    }

    public static Optional<资源> 搜索可用资源(Constant.工序 工序,Date 搜索起始日期,Date 搜索截止日期, double 需求数量){
        return 资源池.values().stream().filter(资源->{
            工序产能 工序产能 = 资源.get工序产能MAP().get(工序);
            Date 资源日期=DateUtil.parse(资源.getDate(),"yyyy/MM/dd");
            if (工序产能==null){
                return false;
            }
            return 工序产能.判断是否可以占用(需求数量)&&资源日期.after(搜索起始日期)&&资源日期.before(搜索截止日期);
        }).findFirst();
    }

    public static 资源 提取资源(Date date){
        资源 资源 = 资源池.get(DateUtil.format(date, "yyyy/MM/dd"));
        if (资源==null){
            return 提取资源(DateUtil.offsetDay(date,-1));
        }
        return 资源;
    }

    public static Map<Constant.工序, 工序产能> 计算日产能(){
        Map<Constant.工序, 工序产能> map = new HashMap<>();
        Arrays.stream(Constant.工序.values()).forEach(_item -> {
            if (StrUtil.isNotEmpty(_item.getCode())) {
                工序产能 工序产能 = 工序产能工厂(_item);
                if (工序产能!=null){
                    map.put(_item, 工序产能);
                }
            }
        });
        return map;
    }

    public static void 创建产能资源池(){
        资源池.clear();
        工厂日历.stream().filter(item -> "1".equals(item.getXxr()))
                .forEach(item -> {
                    Map<Constant.工序, 工序产能> map = 计算日产能();
                    资源池.put(item.getGl(), 资源.of(item.getGl(), map));
                });
    }

    public static 套料图工序 套料图工序工厂(Bom bom) {
        switch (bom.getKw() + bom.getZl()) {
            case "51010":
                return new 二跨T型材面板().小组(bom);
            case "51110":
                return new 二跨T型材面板().大组(bom);
            case "61010":
                return new 三跨平铁().小组(bom);
            case "61110":
                return new 三跨平铁().大组(bom);
            case "64230":
                return new 三跨平铁().焊接机器人肘板(bom);
            case "71010":
                return new 一跨平直大板().小组(bom);
            case "71110":
                return new 一跨平直大板().大组(bom);
            case "81110":
                return new 一跨进线板().大组(bom);
            case "91010":
                return new 二跨超长超宽板().小组(bom);
            case "91110":
                return new 二跨超长超宽板().大组(bom);
            case "101010":
                return new 二跨超长超宽曲板().小组(bom);
            case "101110":
                return new 二跨超长超宽曲板().大组(bom);
            case "111010":
                return new 二跨T型材腹板().小组(bom);
            case "111110":
                return new 二跨T型材腹板().大组(bom);
            case "121010":
                return new 二跨激光切割板().小组(bom);
            case "121110":
                return new 二跨激光切割板().大组(bom);
            case "131010":
                return new 三跨曲板().小组(bom);
            case "131110":
                return new 三跨曲板().大组(bom);
            case "141010":
                return new 三跨厚板().小组(bom);
            case "141110":
                return new 三跨厚板().大组(bom);
            case "151010":
                return new 四跨普通板().小组(bom);
            case "151110":
                return new 四跨普通板().大组(bom);
            case "154230":
                return new 四跨普通板().焊接机器人肘板(bom);
            case "161010":
                return new 七跨型板().小组(bom);
            case "161110":
                return new 七跨型板().大组(bom);
            case "171120":
                return new 光电().小组(bom);
            default:
                return null;
        }
    }

    public static 工序产能 工序产能工厂(Constant.工序 _工序) {
        设备产能接口 _设备产能接口 = getBean(设备产能接口.class);
        List<设备产能> 设备产能 = _设备产能接口.get();
        Map<String, 设备> _设备;
        ImmutableMap.Builder<String, 设备> builder = ImmutableMap.builder();
        switch (_工序) {
            case 上料:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备01上料(item)));
                _设备 = builder.build();
                return new 工序01上料(_设备);
            case 抛丸:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备02抛丸(item)));
                _设备 = builder.build();
                return new 工序02抛丸(_设备);
            case 理料:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备03理料(item)));
                _设备 = builder.build();
                return new 工序03理料(_设备);
            case 划线:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备04划线(item)));
                _设备 = builder.build();
                return new 工序04划线(_设备);
            case 切割:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备05切割(item)));
                _设备 = builder.build();
                return new 工序05切割(_设备);
            case 坡口:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备07坡口(item)));
                _设备 = builder.build();
                return new 工序07坡口(_设备);
            case 型材面板:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备10型材(item)));
                _设备 = builder.build();
                return new 工序10型材(_设备);
            case 曲型:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备08曲面(item)));
                _设备 = builder.build();
                return new 工序08曲面(_设备);
            case 打磨:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备09打磨(item)));
                _设备 = builder.build();
                return new 工序09打磨(_设备);
            case 自由边处理:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备21自由边处理(item)));
                _设备 = builder.build();
                return new 工序21自由边处理(_设备);
            case 光电结束:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备31光电(item)));
                _设备 = builder.build();
                return new 工序31光电(_设备);
//            case 预配盘:
//                return new 工序01上料(_工序,_设备);
//            case 配送:
//                return new 工序01上料(_工序,_设备);
            default:
                return null;
        }
    }

    public static void 加载工厂日历(){
        List<EmGcrl> list = getBean(EmGcrlService.class).getList(new JSONObject());
        工厂日历.clear();
        工厂日历.addAll(list);
    }

    public static void 加载套料图工序对应关系(){
        套料图工序对应关系.clear();
        List<EmSbcnp> list = getBean(EmSbcnpService.class).list();
        Map<String, List<EmSbcnp>> map = list.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()+"_"+l.getGx()));
        map.keySet().forEach(key->{
            String gxCode=key.split("_")[1];
            套料图工序对应关系.put(key,Constant.工序.getGxByCode(gxCode));
        });
    }

    public static void 加载设备信息(){
        List<EmSbjbb> deviceList = getBean(EmSbjbbService.class).list(Wrappers.<EmSbjbb>lambdaQuery().like(EmSbjbb::getScbs, "1"));
        设备列表.clear();
        设备列表.addAll(deviceList);
    }

    public static void 输出排产结果到EXCEL(OutputStream stream){

    }


    public static void 输出排产结果到EXCEL(String fileName){
        try(FileOutputStream fos=new FileOutputStream(fileName)) {
            输出排产结果到EXCEL(fos);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private static <T> T getBean(Class<T> clazz) {
        return SpringContextHolder.getBean(clazz);
    }
    private DataFactory(){}
}
