package com.dsic.gj_erp.pc.dto.data;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.DataFactory;
import com.dsic.gj_erp.pc.dto.套料图工序;
import com.google.common.util.concurrent.AtomicDouble;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Getter
@Setter
public class 按批次合并的钢料需求 {
    private String dcCh;
    private String dcPl;
    private List<String> dcFd;
    private String xzglxq;
    private String dzglxq;
    private DateTime 均衡需求日期;
    private List<Bom> bomList;

    private String 预占资源日期;

    private Map<Constant.工序, AtomicDouble> 产能需求;//fixme 要求必须所有工序都不可以打乱才能用
    private Map<Constant.工序, String> 预占结果;
    public void 计算各工序产能需求(){
        产能需求=new HashMap<>();
        this.bomList.forEach(item->{
            套料图工序 _套料图工序 = DataFactory.套料图工序工厂(item);
            _套料图工序.get工序().forEach(_工序->{
                AtomicDouble aDouble = 产能需求.get(_工序);
                if (aDouble==null){
                    aDouble=new AtomicDouble(0);
                    产能需求.put(_工序,aDouble);
                }
                aDouble.addAndGet(item.根据工序获取产能需求量(_工序));
            });
        });
    }

    public 按批次合并的钢料需求 of(钢料需求 _钢料需求){
        if (this.dcCh==null){
            this.dcCh= _钢料需求.getDcCh();
        }
        if (this.dcPl==null){
            this.dcPl=_钢料需求.getDcPl();
        }
        if (!ObjUtil.equals(_钢料需求.getDcCh(),this.dcCh)||!ObjUtil.equals(_钢料需求.getDcPl(),this.dcPl)){
            return this;
        }
        if (dcFd==null){
            dcFd=new ArrayList<>();
        }
        this.dcFd.add(_钢料需求.getDcFd());
        this.xzglxq= _钢料需求.getXzglxq();
        this.dzglxq= _钢料需求.getDzglxq();
        if (this.bomList==null){
            this.bomList=new ArrayList<>();
        }
        this.bomList.addAll(_钢料需求.getBomList());
        return this;
    }

    public DateTime get均衡需求日期(){
        if (this.均衡需求日期 ==null){
            return DateUtil.parse(this.xzglxq,"yyyy/MM/dd");
        }
        return this.均衡需求日期;
    }

}
