package com.dsic.gj_erp.pc.dto;

import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.service.工序排产处理接口;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.ConcurrentLinkedDeque;

@Getter
@Setter
public abstract class 工序产能 implements 工序排产处理接口 {
    protected Constant.工序 工序;
    protected double 白班时长;
    protected double 二班时长;
    protected double 产能;
    protected volatile double 占用=0.0;
    protected int cd;
    protected Constant.工序 CD所对应的工序;//需要根据对应工序进行计算cd
    protected Map<String,设备> 设备;
    protected ConcurrentLinkedDeque<String> 资源占用图纸表;

    /**
     * 默认构造
     */
    public 工序产能(Constant.工序 工序, Map<String,设备> 设备){
        this.工序=工序;
        this.设备=设备;
        this.白班时长=7;
        this.二班时长=0;
        this.产能=0;
        this.计算产能();
        this.cd=Constant.工序CD.get(工序);
        资源占用图纸表=new ConcurrentLinkedDeque<>();
    }

    public 工序产能(Constant.工序 工序, Map<String,设备> 设备,double 白班时长,double 二班时长){
        this.工序=工序;
        this.设备=设备;
        this.白班时长=白班时长;
        this.二班时长=二班时长;
        this.产能=0;
        this.计算产能();
        this.cd=Constant.工序CD.get(工序);
        this.资源占用图纸表=new ConcurrentLinkedDeque<>();
    }

    private void 计算产能(){
        this.计算工作量();
        this.计算设备工作量();
    }

    public void 计算工作量(){}

    private void 计算设备工作量(){
        this.设备.values().forEach(_设备-> _设备.修正工作量(this.白班时长,this.二班时长));
    }

    public void 修正工作量(double 白班时长,double 二班时长){}

    public Optional<设备> 获取已占用设备(String 占用源){
        return this.设备.values().stream()
                .filter(item -> item.get资源占用图纸表().contains(占用源))
                .findFirst();
    }

    public Optional<设备> 获取可占用设备(double 所需产能){
        return this.设备.values().stream().findAny();
    }

    public boolean 判断设备是否可以占用(String 设备编号,double 所需产能){
        设备 _设备 = this.设备.get(设备编号);
        return _设备.占用+所需产能<=_设备.产能;
    }

    public boolean 判断是否可以占用(double 所需产能){
        return this.占用+所需产能<=this.产能;
    }

    public void 占用资源(double 所需产能){
        this.占用=this.占用+所需产能;
    }

    public void 占用资源(String 占用源){
        this.资源占用图纸表.add(占用源);
    }

    public void 占用设备(String 占用源,double 所需产能, Bom bom){
        Optional<设备> 可占用设备 = this.获取可占用设备(所需产能);
        可占用设备.ifPresent(it->{
            it.占用设备(所需产能);
            it.占用设备(bom);
        });
    }
    public void 强占设备(String 占用源,double 所需产能, Bom bom){
        Optional<设备> _设备 = this.设备.values().stream().findAny();
        _设备.ifPresent(it->{
            it.占用设备(所需产能);
            it.占用设备(bom);
        });
    }

}
