package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.DmSygdxqOld;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqOldService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@Service
public class DmSygdxqServiceImpl extends ServiceImpl<DmSygdxqMapper, DmSygdxq> implements DmSygdxqService {

    @Autowired
    DmSygdxqOldService  oldService;
    @Autowired
    DmSygdMxService sygdMxService;
    @Autowired
    DmBomService bomService;
    @Override
    @Transactional
    public void saveXzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                //存进备份表
                DmSygdxqOld old=  BeanUtil.copyProperties(sygdxq, DmSygdxqOld.class);
                oldService.save(old);
                l.setDrcs(sygdxq.getDrcs()+1);
                l.setXzglxqOld(sygdxq.getXzglxq());
                l.setDrr(username);
                l.setDrrq(day);
                //状态 2拖期 1提前
                if (sygdxq.getXzglxq()!=null&&l.getXzglxq().compareTo(sygdxq.getXzglxq())>0){
                    l.setXqzt("2");
                }
                if (sygdxq.getXzglxq()!=null&&l.getXzglxq().compareTo(sygdxq.getXzglxq())<0){
                    l.setXqzt("1");
                }
                this.update(new UpdateWrapper<DmSygdxq>()
                        .set("xzglxq",l.getXzglxq())
                        .set("xzglxq_old",l.getXzglxqOld())
                        .set("xdb",l.getXdb())
                        .set("xskj",l.getXskj())
                        .set("xpt",l.getXpt())
                        .set("xyw",l.getXyw())
                        .set("xxc",l.getXxc())
                        .set("xtxc",l.getXtxc())
                        .set("drcs",l.getDrcs())
                        .set("xqzt",l.getXqzt())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
                //todo 修正三月滚动
                correctSygdmx(l.getDcCh(),l.getDcPl(),l.getDcFd(),l.getXzglxq());
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
        });
    }

    @Override
    @Transactional
    public void saveDzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                l.setDrr(username);
                l.setDrrq(day);
                this.update(new UpdateWrapper<DmSygdxq>()
                        .set("dzglxq",l.getDzglxq())
                        .set("dzglxq_old",sygdxq.getDzglxq())
                        .set("dqb",l.getDqb())
                        .set("dxc",l.getDxc())
                        .set("dsj",l.getDsj())
                        .set("ddb",l.getDdb())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
        });

    }

    @Override
    public List<DmSygdxq> getXqWithBom(String from, String to) {
        return baseMapper.getXqWithBom(from,to);
    }

    //零件信息
    public void correctSygdmx(String ch,String pl,String fd,String xqsj){
        //根据：本次导入的三月需求期 提取BOM 生成三月需求零件信息
       List<DmSygdMx> list= sygdMxService.list(new QueryWrapper<DmSygdMx>()
               .eq("dc_ch",ch)
               .eq("dc_pl",pl)
               .in("tzbh"," SELECT dm_bom.tzbh FROM dm_bom WHERE dm_bom.dcch='"+ch+"' and dm_bom.pl='"+pl+"' and dm_bom.fd='"+fd+"'"));
      DateTime dateTime= DateUtil.parse(xqsj,"yyyy/MM/dd");
       list.forEach(l->{
           l.setJssj(xqsj);
           l.setSlrq(DateUtil.offsetDay(dateTime,-9).toString());//8
           if (l.getKw().equals("16")){//型材
               l.setPwrq(DateUtil.offsetDay(dateTime,-5).toString());//4
           }else {
               l.setPwrq(DateUtil.offsetDay(dateTime,-8).toString());//7
           }

            l.setHxrq(DateUtil.offsetDay(dateTime,-3).toString());//2
            l.setQgrq(DateUtil.offsetDay(dateTime,-3).toString());//2
           sygdMxService.save(l);
        });

    }
}

