package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.poi.excel.ExcelReader;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.*;
import com.dsic.gj_erp.mapper.jhgk.DmZrcjhMapper;
import com.dsic.gj_erp.service.jhgk.DmZrcjhOldService;
import com.dsic.gj_erp.service.jhgk.DmZrcjhService;
import com.dsic.gj_erp.util.ExcelUtil;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;
import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import static com.dsic.gj_erp.pc.Manager.from;
import static com.dsic.gj_erp.pc.Manager.to;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class DmZrcjhServiceImpl extends ServiceImpl<DmZrcjhMapper, DmZrcjh> implements DmZrcjhService {
    @Resource
    DmZrcjhMapper dmZrcjhMapper;
    @Resource
    ModelMapper modelMapper;

    @Resource
    DmZrcjhOldService oldService;

    @Autowired
    RedisTemplate<String,Object> redisTemplate;

    @Override
    public List<DmZrcjh> getList(JSONObject json) {
        QueryWrapper<DmZrcjh> queryWrapper = new QueryWrapper<>();
//        if(StringUtils.isNotEmpty(json.getString("dcCh"))){
//            queryWrapper.eq("DC_CH",json.getString("dcCh"));
//        }
        if (StringUtils.isNotEmpty(json.getString("gjks"))) {
            String time = json.getString("gjks");
            String startTime = time.split("~")[0];
            String endTime = time.split("~")[1];
            queryWrapper.between("gjks", DateUtil.parse(startTime,"yyyy/MM/dd"), DateUtil.parse(endTime,"yyyy/MM/dd"));
        }
        if (StringUtils.isNotEmpty(json.getString("Zt"))) {
            queryWrapper.eq("zt", json.getString("Zt"));
        }
        if (StringUtils.isNotEmpty(json.getString("dcCh"))) {
            queryWrapper.eq("DC_CH", json.getString("dcCh"));
        }
        queryWrapper.orderByAsc("DC_CH,cast(DC_PL as int)");
        //      queryWrapper.orderByAsc("DC_PL");
        List<DmZrcjh> dmZrcjhs = dmZrcjhMapper.selectList(queryWrapper);
        return dmZrcjhs;
    }

    @Override
    public List<DmZrcjh> upload(MultipartFile file, HttpServletRequest req) throws IOException {
        List<Map<String, Object>> list = ExcelUtil.readZRCJH(file);
        List<DmZrcjh> dmZrcjhs = new ArrayList<>();
        list.forEach(stringObjectMap -> {
            DmZrcjh dmZrcjh = modelMapper.map(stringObjectMap, DmZrcjh.class);
            dmZrcjh.setZt("0");
            String pl = dmZrcjh.getDcPl().length() == 1 ? "00" + dmZrcjh.getDcPl() : dmZrcjh.getDcPl().length() == 2 ? "0" + dmZrcjh.getDcPl() : dmZrcjh.getDcPl();
            dmZrcjh.setDcPl(pl);
            dmZrcjhs.add(dmZrcjh);

        });
        return this.save(req,dmZrcjhs);
    }

    @Override
    public List<DmZrcjh> save(HttpServletRequest req, List<DmZrcjh> dmZrcjhs) {
        String bzr = (String) req.getAttribute("yhms");
        Date date = new Date();

        List<DmZrcjh> saveDmzrcjhList = new ArrayList<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
        String day = sdf.format(date);
        dmZrcjhs.forEach(dmZrcjh -> {
            QueryWrapper<DmZrcjh> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("DC_CH", dmZrcjh.getDcCh());
            queryWrapper.eq("DC_PL", dmZrcjh.getDcPl());
            queryWrapper.eq("DC_FD", dmZrcjh.getDcFd());
            DmZrcjh dmZrcjhOne = dmZrcjhMapper.selectOne(queryWrapper);
            if (ObjectUtil.isNotEmpty(dmZrcjhOne)) {
                //存进备份表
                DmZrcjhOld old=  BeanUtil.copyProperties(dmZrcjhOne, DmZrcjhOld.class);
                oldService.save(old);
                String dmZrcjhOneBzr = dmZrcjhOne.getBzr();
                String dmZrcjhOneBzrq = dmZrcjhOne.getBzrq();
                if (dmZrcjhOneBzr.contains(bzr)) {
                    String[] bzrStr = dmZrcjhOneBzr.split("@");
                    String[] bzrqStr = dmZrcjhOneBzrq.split("@");
                    boolean append = false;
                    for (int i = 0; i < bzrqStr.length; i++) {
                        if (bzrStr[i].equals(bzr) && bzrqStr[i].equals(day)) {
                            append = true;
                            break;
                        }
                    }
                    if (!append) {
                        String appendBzr = (dmZrcjhOneBzr + "@" + bzr);
                        String appendBzrq = (dmZrcjhOneBzrq + "@" + day);
                        dmZrcjh.setBzr(appendBzr);
                        dmZrcjh.setBzrq(appendBzrq);
                        dmZrcjh.setXh(dmZrcjhOne.getXh());
                        updateById(dmZrcjh);

                    }
                } else {
                    dmZrcjh.setBzr(dmZrcjhOneBzr + "@" + bzr);
                    dmZrcjh.setBzrq(dmZrcjhOneBzrq + "@" + day);
                    dmZrcjh.setXh(dmZrcjhOne.getXh());
                    updateById(dmZrcjh);
                }
            } else {
                dmZrcjh.setBzr(bzr);
                dmZrcjh.setBzrq(day);
                saveDmzrcjhList.add(dmZrcjh);
            }
        });

        saveBatch(saveDmzrcjhList);

        List<List<DmZrcjh>> lists = Lists.partition(saveDmzrcjhList, 300);
        for (List<DmZrcjh> list : lists) {
            dmZrcjhMapper.updateCzplpNEW(list);
        }
        return saveDmzrcjhList;
    }

    @Override
    public void tj(List<DmZrcjh> dmZrcjhs) {
        dmZrcjhs.forEach(dmZrcjh -> {
            String zt = dmZrcjh.getZt();
            String setZt = zt.equals("1") ? "0" : "1";
            dmZrcjh.setZt(setZt);
        });
        updateBatchById(dmZrcjhs);
    }

    @Override
    public void sh(List<DmZrcjh> dmZrcjhs) {
        dmZrcjhs.forEach(dmZrcjh -> {
            dmZrcjh.setZt("2");
        });
        updateBatchById(dmZrcjhs);
    }

    @Override
    public void 排产中日程数据加载() {
        redisTemplate.delete("ZRC");
        List<DmZrcjh> list = list(Wrappers.<DmZrcjh>lambdaQuery().between(DmZrcjh::getGjks, from, to));
        list.parallelStream().forEach(item->{
            String key=item.getDcCh()+item.getDcPl()+item.getDcFd();
            redisTemplate.opsForHash().put("ZRC",key,item);
        });
    }

    @Override
    public DmZrcjh 排产获取中日程数据(String key) {
        return (DmZrcjh) redisTemplate.opsForHash().get("ZRC",key);
    }

}
